/*
This is a default core for Grab Any Media 4.0.0.0
*/

/*
Note and resource:
	
	/^(tipo|solo|questo)/gmi
	Search on multiline "\n" no-case sensitive, return array 
	with match http://www.w3schools.com/jsref/jsref_regexp_m.asp


	'unc' option influence :
		popup-link.js
		popup-source.js
		gam.js
		advanced-source.js

*/

/*
	Loaded on BackGround and popup for startup
*/

(function(){

	var core 		= {};

	core.version 	= "1.0.0.6";
	core.message 	= "Update 05.05.2014";

	core.media		= [
	{
		type 	: "video",
		file 	: [
		{
			cod : "flv",
			ext : "(\\.flv)",			
			oct : "(video\\/x\\-flv|video\\/flv|video\\/x\\-f4v)"
		},
		{
			cod : "3gp",
			ext : "(\\.3gp|\\.3gpp2)",		
			oct : "(video\\/3gpp|video\\/3gpp2)"
		},
		{
			cod : "m3u8 (For Apple Itunes)",
			ext : "(\\.m3u8)",		
			oct : "(application\\/vnd\\.apple\\.mpegurl)"
		},
		{
			unc : true,
			cod : "ts (VLC)",
			ext : "(\\.ts)",		
			oct : "(video\\/mp2t)"
		},
		{
			cod : "mp4",
			ext : "(\\.mp4)",		
			oct : "(video\\/mp4|video\\/x\\-mp4)"
		},
		{
			cod : "avi",
			ext : "(\\.avi)", 			
			oct : "(video\\/avi|video\\/x\\-avi)"
		},
		{
			cod : "wmv",
			ext : "(\\.wmv)", 			
			oct : "(video\\/x\\-ms\\-wmv|video\\/x\\-ms\\-wvx)"
		},
		{
			unc : true,
			cod : "mov",
			ext : "(\\.mov)",			
			oct : "(video\\/x\\-quicktime|video\\/quicktime)"
		},
		{
			cod : "webm",
			ext : "(\\.webm)", 			
			oct : "(video\\/webm)"
		},
		{
			cod : "mpg",
			ext : "(\\.mpg)", 			
			oct : "(video\\/mpg|video\\/x\\-mpg)"
		},
		{
			cod : "mpeg",
			ext : "(\\.mpeg)", 			
			oct : "(video\\/mpeg|video\\/x\\-mpeg)"
		},
		{
			cod : "mkv",
			ext : "(\\.mk3d|\\.mkv)", 			
			oct : "(video\\/x\\-matroska|video\\/x\\-matroska\\-3d)"
		},
		{
			cod : "f4m (Manifest)",
			ext : "(\\.f4m)", 			
			oct : "(application\\/f4m\\+xml|video\\/f4m)"
		},
		{
			cod : "f4f (Fragment)",
			ext : "(\\.f4f)", 			
			oct : "(video\\/f4f)"
		},
		{
			unc : true,
			cod : "swf (RTMPDump -W)",
			ext : "(\\.swf)", 			
			oct : "(application\\/x\\-shockwave\\-flash|application\\/x\\-shockwave\\-flash2\\-preview|application\\/futuresplash|image\\/vnd\\.rn\\-realflash)"
		}			
		]
	},
	{
		type 	: "audio",
		file 	: [
		{
			cod : "mp3",
			ext : "(\\.mp3)", 			
			oct : "(audio\\/x\\-mp3|audio\\/x\\-mpeg3|audio\\/x\\-mpg|audio\\/x\\-mpeg|audio\\/mpg|audio\\/mpeg|audio\\/mp3)"
		},
		{
			cod : "ogg",
			ext : "(\\.ogg)", 			
			oct : "(audio\\/ogg)"
		},
		{
			cod : "mka",
			ext : "(\\.mka)", 			
			oct : "(audio\\/x\\-matroska)"
		}
		]
	}
	];

	core.doc 		= [
	{
		type 	: "document",
		file 	: [
		{
			cod : "xml",
			ext : "(\\.xml|\\.smil|\\.csmil|\\.smi|\\.sml|\\.ssmil|\\.ism)", 			
			oct : "(application\\/xml|application\\/atom\\+xml|application\\/xml\\-dtd|application\\/rdf\\+xml|application\\/xhtml\\+xml|text\\/xml|application\\/rss\\+xml|application\\/smil|application\\/smil\\+xml)"
		},
		{
			cod : "json",
			ext : "(\\.json)", 			
			oct : "(application\\/json|text\\/x\\-json)"
		},
		{
			cod : "js",
			ext : "(\\.js)", 			
			oct : "(application\\/javascript|application\\/x\\-javascript|text\\/javascript|text\\/x\\-js)"
		}
		]
	}
	];

	core.proto 		= "(mms:\\/\\/|rtp:\\/\\/|rtsp:\\/\\/|rtmp:\\/\\/|rtmpe:\\/\\/|rtmpt:\\/\\/|rtmps:\\/\\/|rtmpte:\\/\\/)";

	//Add all octect at the proto test match
	var protos = core.proto.replace("(","").replace(")","");

	for(var i = 0; i < core.media.length; i++){
		for(var a = 0; a < core.media[i].file.length; a++){	
			if(core.media[i].file[a].unc)continue;//Uncheck some extension for good filter
			var octect 	= core.media[i].file[a].oct.replace("(","").replace(")","");

			protos+="|"+octect;
		}
	}

	core.proto = "(" + protos + ")";

	if(typeof localStorage['core'] === "undefined")localStorage['core'] = JSON.stringify(core);
	CORE 	= JSON.parse(localStorage['core']);
	SCORE 	= core;
})();

