

(function(C,S){
	if(!C || !S) throw new Error("GLOBAL require CORE !");

	var manifest 	= chrome.runtime.getManifest(),
		O 			= false;
	
	var sets 	= {
		media 		: [],
		documents	: [],
		settings 	: {
			maxFileSize : 2621440,
			checkDG 	: false,
			checkJS 	: false,
			checkJSON	: true,
			checkXML	: true,
			checkIFRAME : false,
			checkSWF 	: false			
		}
	},
	config 	= {
		manifest 		: manifest,
		extVersion 		: manifest.version,
		coreVersion 	: _getCoreVersion(),
		site  			: "http://grabanymedia.altervista.org/",
		searchPage 		: "search-video/?sa=Search&q=",
		checkPage 		: "extension/v4/check-update.php",
		newsPage 		: "extension/v4/last-news.php",
		lastCore 		: "extension/v4/last-core.json",
		updatePath 		: "chrome://extensions/",
		path 			: chrome.extension.getURL("/"),
		iconDisabled 	: chrome.extension.getURL("../img/Grab_Any_Media128_off.png"),
		iconStandard 	: chrome.extension.getURL("../img/Grab_Any_Media128_on.png"),
		iconModerate 	: chrome.extension.getURL("../img/Grab_Any_Media128_moderate.png"),
		iconAggressive 	: chrome.extension.getURL("../img/Grab_Any_Media128_aggressive.png"),
		iconCustom 		: chrome.extension.getURL("../img/Grab_Any_Media128_custom.png")
	};
	
	var glb = function(){};

	glb.prototype = {
		sets 	: sets,
		config 	: config,
		log 	: function(l){if(O)console.log(l)} 
	};


	function _initialize(flag){
		if(typeof localStorage['settings'] === "undefined")localStorage['settings'] = JSON.stringify(sets.settings);
		if(typeof localStorage['core'] === "undefined")localStorage['core'] = JSON.stringify(C);
		if(typeof localStorage['media'] === "undefined")localStorage['media'] = JSON.stringify(sets.media);
		if(typeof localStorage['documents'] === "undefined")localStorage['documents'] = JSON.stringify(sets.documents);
		if(typeof localStorage['last-news'] === "undefined")localStorage['last-news'] = "";

		if(flag)return JSON.parse(flag);
	};

	function _getCoreVersion(){
		var a = _initialize(localStorage["core"]);
		return a.version;
	};

	function _signCore(news){
		localStorage['core'] = JSON.stringify(news);
		return JSON.parse(localStorage['core']);
	};

	function _resetDbmediaAndDocs(){
		localStorage.removeItem("documents");
		localStorage.removeItem("media");
		_initialize();
	};

	function _resetAllDB(){
		C = S;
		for (var key in localStorage){
			//not remove last news for notify becouse this dusturbe
			if(key == "last-news")continue;
			localStorage.removeItem(key);
		}
		_initialize();
	};

	glb.prototype.initialize = function(flag){
		return _initialize(flag);
	};

	glb.prototype.getDBsettings = function(){
		return _initialize(localStorage["settings"]);
	};

	glb.prototype.getDBdocuments = function(){
		return _initialize(localStorage["documents"]);
	};

	glb.prototype.getDBmedia = function(){
		return _initialize(localStorage["media"]);
	};

	glb.prototype.getDBcore = function(){
		return _initialize(localStorage["core"]);
	};

	glb.prototype.getDBlastnews = function(){
		return _initialize(localStorage["last-news"]);
	};

	glb.prototype.setDBsettings = function(news){
		localStorage["settings"] = news;
	};

	glb.prototype.setDBdocuments = function(news){
		localStorage["documents"] = news;
	};

	glb.prototype.setDBmedia = function(news){
		localStorage["media"] = news;
	};

	glb.prototype.setDBcore = function(news){
		localStorage["core"] = news;
	};

	glb.prototype.setDBlastnews = function(news){
		localStorage["last-news"] = news;
	};

	glb.prototype.compareDBlastnews = function(compare){
		return (localStorage["last-news"] == compare);
	};

	glb.prototype.findDBmedia = function(text){
		return (localStorage["media"].indexOf(text) > -1);
	};

	glb.prototype.findDBdocuments = function(text){
		return (localStorage["documents"].indexOf(text) > -1);
	};

	glb.prototype.signCore = function(news){
		return _signCore(news);
	};

	glb.prototype.resetDbmediaAndDocs = function(){
		return _resetDbmediaAndDocs();
	};

	glb.prototype.resetAllDB = function(){
		return _resetAllDB();
	};

	GLB = new glb();
})(CORE,SCORE);