/*
	Author 	 	: Leonardo Ciaccio
	Email 		: leonardo.ciaccio@gmail.com
	WebSite 	: http://free-bookmarklet.weebly.com
	Facebook 	: https://www.facebook.com/FreeBookmarklets
	Google+ 	: https://plus.google.com/100541010954505298321
	Twitter 	: https://twitter.com/AllBookmarklets
	
	**********************************************************************************************************************
	
	Name 		: Preload
	Created		: 18.04.2014 21:00
	Version 	: 3.0.0.0
	
	**********************************************************************************************************************

	Scope 		: Preload of <body>, <frame>, <frameset>, <iframe>, <img>, <input type="image">, <link>, <script>, <style>

	Usage 		: Expose one function called 'preload' then for example

				<!DOCTYPE HTML>
				<html>
					<head lang="en">
						<title>Preload</title>
						<meta charset="utf-8" />
						<script type="text/javascript" src="Pure-JS-Preload-3.0.0.0.js"></script>
						<script type="text/javascript">
							var prl = new preload();
							var els = [
											{
							                	enabled   : true,			
							                    test      : window.jQuery,	
							                    name      : "jQuery",		
							                    tag       : "script",		
							                    rewrite   : false,			 	
							                    appendTo  : document.head,	
							                    onload    : function(){
							                    	console.log("jQuery onload");
							                    },			
							                    attribute : {
							                    	"id" 	: "jQuery-ID",
							                    	"src" 	: "https://ajax.googleapis.com/ajax/libs/jquery/2.1.0/jquery.min.js",
							                    	"type" 	: "text/javascript"
							                    },			                    			
							                    html      : ""				
											},
											{
				                              enabled   : true,
				                              test      : null,
				                              name      : "jQueryUi css",
				                              tag       : "link",
				                              rewrite   : false,
				                              appendTo  : document.head,//document.getElementById("BK-Framework"),
				                              onload    : null,
				                              attribute : {
				                                            "id":"BK-Framework-jQueryUi-css",
				                                            "href":"https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/themes/smoothness/jquery-ui.css",
				                                            "type":"text/css",
				                                            "rel":"stylesheet"
				                                          },
				                              html      : ""
				                            },
				                            {
				                              enabled   : true,
				                              test      : null,
				                              name      : "ScreenShot css",
				                              tag       : "link",
				                              rewrite   : false,
				                              appendTo  : document.head,//document.getElementById("BK-Framework"),
				                              onload    : null,
				                              attribute : {
				                                            "id":"BK-Framework-ScreenShot-css",
				                                            "href":"https://googledrive.com/host/0Bxb8ebYkriL9ZGh5YTBaMmNwelU/Free-Bookmarklet/ScreenShot-This/ScreenShot-This.css",
				                                            "type":"text/css",
				                                            "rel":"stylesheet"
				                                          },
				                              html      : ""
				                            },
				                            {
				                              enabled   : true,//for testing
				                              test      : null,//window.jQuery,//object special test for installation if exist ignore it 
				                              name      : "jQuery",//string for progressive value
				                              tag       : "script",//string default div
				                              rewrite   : false,//bool rewite if "id" set
				                              appendTo  : document.head,//document.getElementById("BK-Framework"),//string default body or set it with obj ex. document.head
				                              onload    : null,//function when loaded
				                              attribute : {
				                                            "id":"BK-Framework-jQuery",
				                                            "src":"https://ajax.googleapis.com/ajax/libs/jquery/2.1.0/jquery.min.js",
				                                            "type":"text/javascript"
				                                          },
				                              html      : ""
				                            },
				                            {
				                              enabled   : true,
				                              test      : null,
				                              name      : "jQuery UI",
				                              tag       : "script",
				                              rewrite   : false,
				                              appendTo  : document.head,//document.getElementById("BK-Framework"),
				                              onload    : null,
				                              attribute : {
				                                            "id":"BK-Framework-jQueryUi",
				                                            "src":"https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/jquery-ui.min.js",
				                                            "type":"text/javascript"
				                                          },
				                              html      : ""
				                            },
				                            {
				                              enabled   : true,
				                              test      : window.html2canvas,
				                              name      : "Html2Canvas",
				                              tag       : "script",
				                              rewrite   : false,
				                              appendTo  : document.head,
				                              onload    : null,
				                              attribute : {
				                                            "id":"BK-Framework-h2c",
				                                            "src":"https://googledrive.com/host/0Bxb8ebYkriL9ZGh5YTBaMmNwelU/Free-Bookmarklet/ScreenShot-This/html2canvas.js",
				                                            "type":"text/javascript"
				                                          },
				                              html      : ""
				                            }
								],
								opt = {
									debug 		: true,
									showBar 	: true,
									onLoaded 	: function(){
										console.log("Terminato");
									},
									onProgress 	: function(){
										console.log("Progress : %" + prl.getProgressValue());
									}
								};

								window.onload = function(){
									prl.installElements(els,opt);
									//console.log(prl.version());
								};
						</script>
						
					</head>
					<body>				
					</body>
				</html>

	Function 	: 	.installElements(els,opt)		
					.getProgressValue()		
	
	**********************************************************************************************************************
*/


(function(W,D){

	//Private vars
	var O 			= true,
		bar 		= false,
		maxbar 		= 100,
		log 		= function(l){if(O)console.log(l)},
		elements 	= 0,
		allels 		= 0,
		version 	= "3.0.0.0",
		author 		= "Leonardo Ciaccio";

	preload = function(){};

	preload.prototype = {
		version : function(){return version;},
		author 	: function(){return author}
	};

	//Private function add event listner cross browser
    function _AddEvent(evnt, elem, func) {
      try{
        if(elem.addEventListener){ 
              elem.addEventListener(evnt,func,false);
          }else if(elem.attachEvent){
               var r = elem.attachEvent("on"+evnt, func);
          }
          return true;
      }catch(e){
        log("Preload _AddEvent : " + e.message);
        return false;
      }       
    };// ---> _AddEvent()

	//Private function destroy html element by id
	function _DestroyElement(eID){//eID = string of ID
      var a,b,c = 0;
      try{
        a = D.getElementById(eID);
        if(a){
          b = a.parentNode;
          if(b){
            b.removeChild(a);
            c = 1;
          }else{
            c = -2;
          }   
        }else{
          c = -1;
        }
        return c;
      }catch(e){
        log("Preload _DestroyElement : " + e.message);
        return c;
      }
    };// ---> _DestroyElement()

    //Private function install html element by 'els' schema
    function _InstallElements(els,prg,end){
      	try{
	      	els = els || [];
	      	prg = prg || function(){log("Preload _InstallElements : installing element " + els.length);};
	    	end = end || function(){return false;};

    		elements = els.length;

	    	prg(); _ShowBar();
	    		  		
	        if(els.length < 1)return end();
	        
	        var ele 		= els[0],                   
		        callback 	= function(){
	            	els.splice( 0, 1 );
	            	return _InstallElements(els,prg,end);
	          	},
	          	testLoad = /(body|frame|frameset|iframe|img|input|link|script|style)/gi;//input type='image'
	        
	        ele.enabled 	= ele.enabled 	|| true;
	        ele.test 		= ele.test 		|| null; 
	        ele.name 		= ele.name 		|| "Unknown";
	        ele.tag 		= ele.tag 		|| "";
	        ele.rewrite 	= ele.rewrite	|| false;
	        ele.appendTo 	= ele.appendTo	|| null;
	        ele.onload 		= ele.onload	|| null;
	        ele.attribute	= ele.attribute	|| null; 
	        ele.html 		= ele.html		|| "";

	        if(!ele.enabled)return callback();
	        if(ele.test)return callback();

	        if(!ele.tag)return callback();
	        if(!ele.appendTo)return callback();
	        if(!ele.attribute)return callback();
	        

	        if(ele.attribute.id){
		        if(D.getElementById(ele.attribute.id) && !ele.rewrite)return callback();
		        if(D.getElementById(ele.attribute.id) && ele.rewrite){
		        	if(_DestroyElement(ele.attribute.id) != 1){
		        		log("Preload _InstallElements : problem with rewrite '" + ele.attribute.id+"'");
		        		return callback();
		        	}
		        }	
	        }          

          	var e = D.createElement(ele.tag);         
          
            for(var k in ele.attribute){
              e.setAttribute(k,ele.attribute[k]);
            }          

          	if(ele.html)e.innerHTML = ele.html;         
          
          	if(ele.tag.match(testLoad)){
            	_AddEvent("load",e,function(){
              		if(ele.onload)ele.onload();
              		callback();
            	});
          	}	          

          	ele.appendTo.appendChild(e);
          	log("Preload _InstallElements : installed " + ele.name);
          	if(!ele.tag.match(testLoad))return callback();
      }catch(e){    
        log("Preload _InstallElements : " + e.message); 
        return false;
      }
    };// ---> _InstallElements()

    //Private function retreview the percentage loading
    function _getProgressValue(){
    	if ( !elements ) return maxbar;
		var q = ( elements / ( allels / maxbar ) );
		return (maxbar - q.toFixed(0));
    };// ---> _getProgressValue()

    //Private function add event listner cross browser
    function _ShowBar() {
    	try{
    		if(!bar)return false;

    		var id		= "preload-bar",
    			div 	= D.getElementById(id),
        		value 	= _getProgressValue(),
        		style 	= "box-shadow: 0px 1px 3px #494949;border-bottom: 1px solid rgb(119, 118, 118);background-color:rgb(230, 0, 0);position:fixed;top:0px;left:0px;height:3px;width:" + value + "%";

        	if(value >= maxbar)return _DestroyElement(id);

        	if(!div){
        		div = D.createElement("div");
        		div.setAttribute("id",id);
        		D.body.appendChild(div);
        	}
        	div.setAttribute("style",style);

    	}catch(e){
    		log("Preload _ShowBar : " + e.message);
    		return false;
    	}       
    };// ---> _ShowBar()

    //Public function and strarter
    preload.prototype.installElements = function(els,opt){
    	try{
    		els = els || [
    			{
                	enabled   : false,	//optional 	bool[true] 			for testing
                    test      : null,	//optional 	object[null] 		ex. window.jQuery 
                    name      : "",		//optional 	string["Unknown"] 	for progressive value
                    tag       : "",		//require 	string[""] 
                    rewrite   : false,	//optional 	bool[false]	 		rewrite if "id" is set
                    appendTo  : null,	//require 	object[null] 		ex. document.head
                    onload    : null,	//optional 	function[null] 		when loaded
                    attribute : null,	//require 	obj-element[null]	ex. {"id":"name-id"}
                    html      : ""		//optional 	string[""]	 		for innerHTML
                }
    		];

    		opt = opt || {
    			bebug 		: false,	//optional 	bool 		for log event
    			onLoaded 	: null,		//optional 	function	called on loaded all elements
    			onProgress 	: null,		//optional 	function	called on every installation
    			showBar 	: false 	//optional 	bool 		show bar progress
    		};

    		O = opt.debug; bar = opt.showBar; elements = els.length; allels = els.length;

    		_InstallElements(els,opt.onProgress,opt.onLoaded);

    	}catch(e){
    		log("Preload InstallElements : " + e.message);
    	}
    };// ---> InstallElements()

    //Public function retreview the percentage loading
    preload.prototype.getProgressValue = function () {
		return _getProgressValue();
	};// ---> getProgressValue()


    log("Preload installed !");
    
})(window,document);